#ifndef MYMODEL_H
#define MYMODEL_H

#include <QAbstractItemModel>

struct CItem  {
    CItem( QString name, CItem * parent );

    QString mName;
    CItem * mParent;
    std::vector<CItem*> mChildren;
};

class MyModel : public QAbstractItemModel
{
    Q_OBJECT
public:
    MyModel( QObject * parent = 0 );

public:
    virtual QModelIndex index(int row, int column, const QModelIndex &parent) const;
    virtual QModelIndex parent(const QModelIndex &child) const;
    virtual int rowCount(const QModelIndex &parent) const;
    virtual int columnCount(const QModelIndex &parent) const;
    virtual QVariant data(const QModelIndex &index, int role) const;

private:
    CItem * mRoot;
    CItem * getItem( const QModelIndex & idx ) const;
};

#endif // MYMODEL_H
